%define glx_ver			20001222
%define glx_mesa_version 	3.2.1
%define mesa_so_version 	1.4.501
%define GLwrapper_version	0.1.8
%define BUILD_LIBGLU 1

Name: Mesa
Version: 5.0.1
Release: alt7
Summary: OpenGL 1.3 compatible 3D graphics library
Group: System/Libraries
Url: http://www.mesa3d.org


Source: ftp://ftp.mesa3d.org/pub/mesa/MesaLib-%version.tar.bz2
Source1: ftp://ftp.mesa3d.org/pub/mesa/MesaDemos-%version.tar.bz2
Source2: http://utah-glx.sourceforge.net/glx-%glx_ver.tar.bz2
Source4: %name-icons.tar.bz2
Source5: ftp://ftp.mesa3d.org/pub/mesa/MesaLib-%glx_mesa_version.tar.bz2
Source6: GLwrapper-%GLwrapper_version.tar.bz2

Patch1: %name-4.0.3-remove-rpath.patch
Patch2: %name-GLUtesselator-back.patch.bz2
Patch3: %name-3.3-gcc-2.96.patch
Patch4: %name-3.5-opt.patch
Patch10: glx-rename_glx_so.patch
#Patch12: Mesa-4.0.3-3.2.1-mesa_conf.patch
#Patch13: Mesa-3.4-glxARB.patch.bz2
#Patch14: glx-mach64tmp.patch
Patch15: GLwrapper-0.1.8-nv_and_fglrx.patch
#Patch16: Mesa-4.0.3-libraries_ld.patch

License: MIT
Prefix: /usr/X11R6
Requires: tcl
BuildPreReq: binutils >= 2.9.1.0.19a gcc-c++
BuildRequires: XFree86-devel tcl kernel-headers-std

%add_optflags %optflags_nocpp

%package -n libglut
Summary: Files for Mesa (glut lib)
Group: System/Libraries
Obsoletes: Mesa-common
Provides: Mesa-common = %version

%package -n libglut-devel
Summary: Development files for GLU lib
Group: Development/C
Requires: libglut = %version-%release, XFree86-devel
Obsoletes: Mesa-common-devel
Provides: Mesa-common-devel = %version

%package -n libGLU
Summary: Files for Mesa (glut lib)
Group: System/Libraries
Conflicts: XFree86-libs < 4.2.1

%package -n libGLU-devel
Summary: Development files for GLU lib
Group: Development/C
Requires: libGLU = %version-%release, XFree86-devel

%package -n libGLwrapper
Summary: GLwrapper library for automatic selecting right libGL library
Group: System/Libraries
Requires: Mesa

%package -n glx
Summary: GLX and libGL library for XFree86-3.3.6
Group: System/Libraries
Requires: XFree86-libs, libGLwrapper

%package demos
Summary: Demos for Mesa (OpenGL compatible 3D lib)
Group: Graphics
Requires: libglut = %version-%release

%description
Mesa is an OpenGL 1.3 compatible 3D graphics library.

%description -n libGLwrapper
GLwrapper library for automatic selecting right libGL library.

You need to install this package if You want to use both XFree86-3.3.6
and XFree86-4.x, or use commercial nVidia XFree86-4.x driver.

%description -n glx
GLX and libGL library for XFree86-3.3.6.

You need to install this package if You want to run XFree86-3.3.6
with GLX hardware extension.

%description -n libglut
Mesa is an OpenGL 1.3 compatible 3D graphics library.
This packet contains libglut part of Mesa.

%description -n libglut-devel
Mesa is an OpenGL 1.3 compatible 3D graphics library.

This package contains the headers of libglut needed to compile Mesa programs.

%description -n libGLU
Mesa is an OpenGL 1.3 compatible 3D graphics library.
This packet contains libGLU part of Mesa.

%description -n libGLU-devel
Mesa is an OpenGL 1.3 compatible 3D graphics library.

This package contains the headers of libGLU needed to compile Mesa programs.

%description demos
Mesa is an OpenGL 1.3 compatible 3D graphics library.

This package contains some demo programs for the Mesa library.

%prep
%setup -q -n Mesa-%version

#Mesa-demos
tar xfj %SOURCE1 -C ../

# utah_glx
tar xfj %SOURCE2

# Mesa to use with utah_glx (while waiting for support of 3.3)
tar xfj %SOURCE5 -C glx/

# Get GLwrapper library that make a true wrapp of libGL API (fpons).
tar xfj %SOURCE6
cp GLwrapper-%GLwrapper_version/README README.GLwrapper

# patch to restore GLUtesselator from Mesa-3.2
# which has been removed but cause some program crazy!
# so GLU get back compliant with 1.2.
#%patch2 -p1 -b .tess

# (chmou) Fix gcc2.96 compilation
%patch3 -p1
%patch4 -p1 -b .opt

# patch to rename glx.so to glx-3.so
%patch10 -p1 -b .rename_glx

# patch to rename mesa.conf file to /etc/X11/mesa.conf
# all arch are taken, even if code is not compiled.
#%patch12 -p1 -b .mesa_conf
#%patch13 -p1 -b .glxARB
#%patch14 -p1 -b .glxtmp
%patch15 -p1 -b .nvidia
#%patch16 -p1

perl -pi -e "s/-O3/$RPM_OPT_FLAGS/" Make-config

pushd demos && {
	for i in *.c; do
	perl -pi -e "s|\.\./images/|%prefix/lib/mesa-demos-data/|" $i ;
	done
	perl -pi -e "s|isosurf.dat|%prefix/lib/mesa-demos-data/isosurf.dat|" isosurf.c
} && popd

# [FP] fix libtool.
rm -f acinclude.m4
for file in m4/*.m4; do
  case $file in
  *libtool.m4) ;; # skip, system libtool is better
  *.m4) cat $file >> acinclude.m4
  esac
done
#rm -f ltmain.sh ltconfig
#libtoolize --automake --copy --force
#aclocal
#autoheader_2.5
#automake -a -c
#autoconf_2.5

# remove rpath.
%patch1 -p1

%build
# [GG] something wrong with filenames...
ln -sf ./common_x86_asm.S ./src/X86/common_x86asm.S
ln -sf ./common_x86_asm.h ./src/X86/common_x86asm.h

export TCLSH=/usr/bin/tclsh

%ifarch i386 i486
CFLAGS=$RPM_OPT_FLAGS CXXFLAGS=$RPM_OPT_FLAGS CC="gcc" CPP="gcc -E" CXX="g++ $RPM_OPT_FLAGS" \
	./configure	--prefix=%prefix \
			--sysconfdir=/etc/X11 \
			--target=%_target_cpu-alt-linux-gnu \
			--disable-mmx \
			--disable-3dnow \
			--enable-osmesa \
			--without-glide \
			--without-svga \
			--without-ggi
%else
CFLAGS=$RPM_OPT_FLAGS CXXFLAGS=$RPM_OPT_FLAGS CC="gcc" CPP="gcc -E" CXX="g++ $RPM_OPT_FLAGS" \
	./configure	--prefix=%prefix \
			--sysconfdir=/etc/X11 \
			--target=%_target_cpu-alt-linux-gnu \
			--enable-x86 \
			--enable-mmx \
			--enable-3dnow \
			--enable-sse \
			--enable-osmesa \
			--without-glide \
			--without-svga \
			--without-ggi
%endif

make

pushd demos
#         multiarb osdemo paltex pointblast reflect renormal \
for i in bounce clearspd drawpix gamma gears glinfo glutfx isosurf morph3d \
         multiarb paltex pointblast reflect renormal \
         spectex stex3d tessdemo texcyl texobj trispd winpos; do
	make $i
done
popd

cd glx
cp -fv ../config.sub ./

%ifarch i386 i486
# (Dadou) Don't remove --host. It's needed if you build on arch <> than --target
# (configuration is very bugged)
# (Dadou) Supports for mmx and 3dnow are useless for i386 and i486
CC="gcc" CPP="gcc -E" CXX="g++" CFLAGS=$RPM_OPT_FLAGS ./autogen.sh	--with-chipset=all \
					--with-mesa=Mesa-3.2.1 \
					--enable-extra \
					--disable-mtrr \
					--disable-agp \
					--disable-glut \
					--disable-osmesa \
					--prefix=%prefix \
					--sysconfdir=/etc/X11 \
					--target=%_target_cpu-alt-linux-gnu \
					--host=%_target_cpu-alt-linux-gnu \
					--without-mmx-asm \
					--without-3dnow-asm
%else
CC="gcc" CPP="gcc -E" CXX="g++" CFLAGS=$RPM_OPT_FLAGS ./autogen.sh	--with-chipset=all \
					--with-mesa=Mesa-3.2.1 \
					--enable-extra \
    					--enable-mtrr \
					--enable-agp \
					--disable-glut \
					--disable-osmesa \
    					--prefix=%prefix \
					--with-moduledir=%prefix/lib/modules \
    					--sysconfdir=/etc/X11 \
    					--target=%_target_cpu-alt-linux-gnu \
					--host=%_target_cpu-alt-linux-gnu
%endif
# Arg docs sux ((Dadou) "are not OK", it's better ;)
pushd docs
cat <<EOF > config.cache
ac_cv_path_install=${ac_cv_path_install='/usr/bin/install -c'}
ac_cv_prog_CP=${ac_cv_prog_CP='cp -f'}
ac_cv_prog_LN_S=${ac_cv_prog_LN_S='ln -s'}
ac_cv_prog_MKDIR=${ac_cv_prog_MKDIR='mkdir -p'}
ac_cv_prog_MV=${ac_cv_prog_MV='mv -f'}
ac_cv_prog_RM=${ac_cv_prog_RM='rm -f'}
ac_cv_prog_have_dvips=${ac_cv_prog_have_dvips=no}
ac_cv_prog_have_jade=${ac_cv_prog_have_jade=no}
ac_cv_prog_have_jadetex=${ac_cv_prog_have_jadetex=no}
ac_cv_prog_have_lynx=${ac_cv_prog_have_lynx=no}
ac_cv_prog_have_ps2pdf=${ac_cv_prog_have_ps2pdf=no}
ac_cv_prog_make_make_set=${ac_cv_prog_make_make_set=yes}
EOF
./configure --enable-text --enable-html --enable-ps --enable-pdf
popd

make
cd ..

# build GLwrapper.
CC="gcc" make prefix=%prefix mesa_so_version=%mesa_so_version -C GLwrapper-%GLwrapper_version

%install
mkdir -p $RPM_BUILD_ROOT%prefix/lib/mesa-demos-data
mkdir -p $RPM_BUILD_ROOT/usr/include
mkdir -p $RPM_BUILD_ROOT%prefix/etc
make DESTDIR=$RPM_BUILD_ROOT install
if [ ! -e $RPM_BUILD_ROOT%{prefix}/lib/libGL.la ]; then
  echo "PROBLEM INSTALLING MESA LA LIBRARY"
  if [ -e src/libGL.la ]; then
    install -m 0644 src/libGL.la $RPM_BUILD_ROOT%{prefix}/lib/libGL.la
  fi
fi
if [ ! -e $RPM_BUILD_ROOT%{prefix}/lib/libGL.so.%{mesa_so_version} ]; then
  echo "PROBLEM INSTALLING MESA SO LIBRARY"
  if [ -e src/.libs/libGL.so.%{mesa_so_version} ]; then
    install -m 0755 src/.libs/libGL.so.%{mesa_so_version} $RPM_BUILD_ROOT%{prefix}/lib/libGL.so.%{mesa_so_version}
  elif [ -e src/.libs/libGL.so.%{mesa_so_version}U ]; then
    install -m 0755 src/.libs/libGL.so.%{mesa_so_version}U $RPM_BUILD_ROOT%{prefix}/lib/libGL.so.%{mesa_so_version}
  fi
fi

#install -m 0644 include/GL/glext.h $RPM_BUILD_ROOT%prefix/include/GL

mkdir -p $RPM_BUILD_ROOT%prefix/bin
#         multiarb osdemo paltex pointblast reflect renormal \
for i in bounce clearspd drawpix gamma gears glinfo glutfx isosurf morph3d \
         multiarb paltex pointblast reflect renormal \
         spectex stex3d tessdemo texcyl texobj trispd winpos; do
  cp -v demos/.libs/$i $RPM_BUILD_ROOT%prefix/bin
done

# (fg) So that demos at least work :)
cp -v images/*rgb demos/isosurf.dat $RPM_BUILD_ROOT%prefix/lib/mesa-demos-data

# menu for demos
install -m 755 -d $RPM_BUILD_ROOT%_menudir
cat <<EOF >$RPM_BUILD_ROOT%_menudir/Mesa-demos
?package(Mesa-demos):command="%prefix/bin/gears" \
                     icon="mesa-demos-gears.xpm" \
                     needs="x11" \
                     section="Amusement/Toys" \
                     title="Mesa gears" \
                     longtitle="Gears 3D demonstration from Mesa 3D"

?package(Mesa-demos):command="%prefix/bin/reflect" \
                     icon="mesa-demos-reflect.xpm" \
                     needs="x11" \
                     section="Amusement/Toys" \
                     title="Mesa reflect" \
                     longtitle="Reflect 3D demonstration from Mesa 3D"

?package(Mesa-demos):command="%prefix/bin/morph3d" \
                     icon="mesa-demos-morph3d.xpm" \
                     needs="x11" \
                     section="Amusement/Toys" \
                     title="Mesa morph" \
                     longtitle="Morph 3D demonstration from Mesa 3D"
EOF

# icons for three demos examples [we lack a frontend
# to launch the demos obviously]
install -m 755 -d $RPM_BUILD_ROOT%_miconsdir
install -m 755 -d $RPM_BUILD_ROOT%_iconsdir
install -m 755 -d $RPM_BUILD_ROOT%_liconsdir
tar yxvf %SOURCE4 -C $RPM_BUILD_ROOT%_iconsdir

mkdir -p $RPM_BUILD_ROOT/usr/bin
cat > $RPM_BUILD_ROOT/usr/bin/glx <<EOF
#!/bin/sh
LD_PRELOAD=%prefix/lib/libGL.so.1.0 "\$@"
EOF
chmod +x $RPM_BUILD_ROOT/usr/bin/glx
cat > $RPM_BUILD_ROOT/usr/bin/noglx <<EOF
#!/bin/sh
LD_PRELOAD=%prefix/lib/libGL.so.1.2.%mesa_so_version "\$@"
EOF
chmod +x $RPM_BUILD_ROOT/usr/bin/noglx

## glx
cd glx
#beware of installing the minimun as Mesa version are not the same!
make DESTDIR=$RPM_BUILD_ROOT sysconfdir=/etc/X11 SUBDIRS="libGL servGL" install
cd ..

# install GLwrapper
make DESTDIR=$RPM_BUILD_ROOT install -C GLwrapper-%GLwrapper_version

cd $RPM_BUILD_ROOT/usr/include
ln -sf ../X11R6/include/GL GL

cd $RPM_BUILD_ROOT/%prefix/lib/
ln -sf libGL.so.1 libGL.so
ln -sf libGLwrapper.so.%GLwrapper_version libGL.so.1
ln -sf libglut.so.3 libglut.so

# (gc) add Mesa symlinks for compatibility
# (fpons) modified to be hard coded to true Mesa library.
ln -sf libGL.so.%mesa_so_version libMesaGL.so
ln -sf libGL.so.%mesa_so_version libMesaGL.so.1
ln -sf libGL.so.%mesa_so_version libMesaGL.so.4
ln -sf libGL.so.1.0 libMesaGL.so.1.0

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n glx -p /sbin/ldconfig

%post -n libGLwrapper -p /sbin/ldconfig

%post -n libglut -p /sbin/ldconfig

%postun -n libglut -p /sbin/ldconfig

%if %BUILD_LIBGLU
%post -n libGLU -p /sbin/ldconfig

%postun -n libGLU -p /sbin/ldconfig
%endif

%post demos
%update_menus

%postun demos
%clean_menus

%files
%doc docs/COPYRIGHT docs/README docs/README.X11
%prefix/lib/libOSMesa.so.*
%prefix/lib/libGL.so.1.4*
%prefix/lib/libMesaGL.so
#%prefix/lib/libMesaGL.so.1.0
#%prefix/lib/libMesaGL.so.4
%config(noreplace) /etc/X11/mesa.conf

%files -n glx
%config(noreplace) /etc/X11/glx.conf
%prefix/lib/libGL.so.1.0
%prefix/lib/libMesaGL.so.1.0
%prefix/lib/modules/*
%doc glx/docs/README.*
/usr/bin/glx
/usr/bin/noglx

%files -n libGLwrapper
%prefix/lib/libGLwrapper.so*
%prefix/lib/libGL.so.1
%doc README.GLwrapper

%files -n libglut
%doc docs/COPYRIGHT docs/README docs/README.X11
%prefix/lib/libglut.so.*

%files -n libglut-devel
%prefix/include/GL/glut.h
%prefix/lib/libglut.so
#%prefix/lib/libglut.la

%if %BUILD_LIBGLU
%files -n libGLU
%doc docs/COPYRIGHT docs/README docs/README.X11
%prefix/lib/libGLU.so.*

%files -n libGLU-devel
%prefix/include/GL/glu.h
%prefix/lib/libGLU.so
#%prefix/lib/libGLU.la
%endif

%files demos
%doc docs/COPYRIGHT docs/README docs/README.X11
%prefix/bin/*
%dir %prefix/lib/mesa-demos-data
%prefix/lib/mesa-demos-data/*
%_menudir/Mesa-demos
%_miconsdir/*demos*.xpm
%_iconsdir/*demos*.xpm
%_liconsdir/*demos*.xpm

%changelog
* Thu Oct 02 2003 Rider <rider@altlinux.ru> 5.0.1-alt7
- enable build libOSMesa (fixed bug #3090)

* Wed Oct 01 2003 Rider <rider@altlinux.ru> 5.0.1-alt6
- fix requires and provides

* Fri Sep 26 2003 Anton Farygin <rider@altlinux.ru> 5.0.1-alt5
- added check in to libGLwrapper for ATI math based video cards

* Tue Jul 29 2003 Peter Novodvorsky <nidd@altlinux.com> 5.0.1-alt4
- updated ALT_MESA and MESA versions.

* Wed Jul 16 2003 Peter Novodvorsky <nidd@altlinux.com> 5.0.1-alt3
- updated Mesa to 5.0.1
- added fglrx support in GLwrapper

* Thu Oct 03 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.3-alt3
- Rebuild with gcc 3.2

* Wed Sep 18 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.3-alt2
- Fixed linking libraries
- Removed .la files from devel package

* Fri Sep 06 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.3-alt1
- 4.0.3
- Now we building libGLU packages
- build with gcc 2.96
- Fixed rpath

* Mon Apr 16 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.2-alt1
- 4.0.2

* Mon Mar 18 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.1-alt1
- 4.0.1
- Some spec cleanup

* Fri Nov 16 2001 Konstantin Volckov <goldhead@altlinux.ru> 4.0-alt1
- 4.0

* Tue Jul 10 2001 Konstantin Volckov <goldhead@altlinux.ru> 3.5-alt2
- Fixed bug with files in Mesa-demos
- Compile c++ files with optimization
- Added SSE optimization
- Return back libGLU and added libGLU & libGLU-devel packages, define it
  for build it
- Disabled osmesa build
- Fixed SGIX features in libglut - they're not present in Mesa 3.4.2

* Sat Jun 30 2001 Mikhail Zabaluev <mhz@altlinux.ru> 3.5-alt1.1
- added -fno-exceptions -fno-rtti to optflags

* Wed Jun 27 2001 Konstantin Volckov <goldhead@altlinux.ru> 3.5-alt1
- New version
- Some spec cleanup
- Added MesaOS to Mesa package

* Thu Jun 7 2001 Konstantin Volckov <goldhead@altlinux.ru> 3.4.2-alt1
- New Mesa version
- Remove changelog messages before Jan 2001
- Remove libGLU library. It's now in XFree86-libs package.
- Added new packages - libglut, libglut-devel, glx, libGLwrapper
- Patched libGLwrapper for nVidia commercial driver compatibility
- Some spec cleanup

* Sun Feb 25 2001 AEN <aen@logic.ru>	3.4.1-ipl2mdk
- build 3.4.1 in RE environment
- cleanup spec

* Thu Feb 15 2001 Franois Pons <fpons@mandrakesoft.com> 3.4.1-1mdk
- 3.4.1 and remove GLUtesselator patch.

* Wed Jan 24 2001 Giuseppe Ghib <ghibo@mandrakesoft.com> 3.4-8mdk
- patched mach64dmainit.c from CVS. Now /tmp/glx* is
  safely cleaned for mach64 on X exits.

* Mon Jan 22 2001 AEN <aen@logic.ru>
- RE adaptation

* Tue Jan 02 2001 Franois Pons <fpons@mandrakesoft.com> 3.4-7mdk
- updated GLwrapper with 0.1.4.
